CREATE TABLE IF NOT EXISTS `#__customgallery_settings` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `param_name` varchar(128) NOT NULL,
  `param_label` varchar(250) default NULL,
  `param_value` varchar(250) default NULL,
  `tab` tinyint(4) NOT NULL default '0',
  `type` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__customgallery_galleries` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `category_id` int(11) unsigned default NULL,
  `name` varchar(250) NOT NULL,
  `description` text,
  `entry_id` int(11) unsigned default NULL,
  `create_date` datetime NOT NULL,
  `published` tinyint(1) NOT NULL default '1',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__customgallery_categories` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `name` varchar(250) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__customgallery_entries` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `gallery_id` int(11) unsigned NOT NULL,
  `category_id` int(11) unsigned NOT NULL,
  `name` varchar(250) NOT NULL,
  `description` text NOT NULL,
  `type` tinyint(1) NOT NULL default '0',
  `filename` varchar(250) NOT NULL,
  `media_id` varchar(64) default NULL,
  `media_type` tinyint(1) default NULL,
  `create_date` datetime NOT NULL,
  `published` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__customgallery_customfieldoptions` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `field_id` int(11) unsigned NOT NULL,
  `text` varchar(250) NOT NULL,
  `value` varchar(250) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__customgallery_customfields` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `categories` varchar(254) default NULL,
  `name` varchar(250) NOT NULL,
  `type` tinyint(1) NOT NULL default '1',
  `ordering` int(11) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__customgallery_customdata` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `entry_id` int(11) unsigned NOT NULL,
  `field_id` int(11) unsigned NOT NULL,
  `value` varchar(250) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__customgallery_ratings` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `entry_id` int(11) unsigned NOT NULL,
  `ip_address` varchar(16) NOT NULL,
  `rating` tinyint(4) NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `ip_address` (`ip_address`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__customgallery_comments` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `entry_id` int(11) unsigned NOT NULL,
  `username` varchar(30) default NULL,
  `title` varchar(50) NOT NULL,
  `details` text,
  `ip_address` varchar(15) NOT NULL,
  `published` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

