<?php
if( !defined( '_VALID_MOS' ) && !defined( '_JEXEC' ) ) die( 'Direct Access to '.basename(__FILE__).' is not allowed.' );

/**
*
* @package Gigabyte WebSolutions - Easy Installer
* @copyright: 2008 Aroms Emmanuel Aigbehi;
* email: Info@Joomlatag.com
* host: www.joomlatag.com
* development:  Andrey Kvasnevskiy-OrdaSoft(); 
* Homepage: 
* @version: 1.0 $
*
**/

/**
* EasyInstaller database table class
*/
class mosEasyInstaller extends JTable {

	/** @var int Primary key */
	var $id=null;
  /** @var varchar(200) */
	var $app_name=null;
  /** @var varchar(200) */
	var $app_real_name=null;
	/** @var varchar(300) */
	var $app_image_path=null;
	/** @var TEXT */
	var $app_descr=null;
	/** @var varchar(300)  */
	var $app_descr_url=null;
  /** @var varchar(300) */
	var $app_url=null;
	/** @var varchar(10) */
	var $app_version=null;
	/** @var varchar(10) */
	var $app_version_installed=null;
  /** @var varchar(200) */
	var $app_authors=null;
  /** @var varchar(200) */
	var $app_authors_url=null;
  /** @var varchar(200) */
	var $app_authors_email=null;
  /** @var ENUM */
	var $app_type=null;
  /** @var ENUM */
	var $app_real_type=null;
  /** @var varchar(45) */
	var $app_release_date=null;
  /** @var int */
	var $app_recommended=null;
  /** @var int */
	var $app_not_commercial=null;
  /** @var int */
	var $app_relate_id=null;
	/** @var varchar(100) */
	var $category=null;

	/**
	* @param database - A database connector object
	*/
	function mosEasyInstaller( &$db ) {
		//$this->mosDBTable( '#__easy_installer', 'id', $db );
		parent::__construct( '#__easy_installer', 'id', $db );
	}

	function toXML(& $xmlDoc){
		//create and append name element
		$retVal = & $xmlDoc->createElement("app_data");

		$app_name = & $xmlDoc->createElement("app_name");
		$app_name->appendChild($xmlDoc->createTextNode($this->app_name));
		$retVal->appendChild( $app_name);

		$app_real_name = & $xmlDoc->createElement("app_real_name");
		$app_real_name->appendChild($xmlDoc->createTextNode($this->app_real_name));
		$retVal->appendChild( $app_real_name);
		$app_image_path = & $xmlDoc->createElement("app_image_path");
		$app_image_path->appendChild($xmlDoc->createTextNode($this->app_image_path ));
		$retVal->appendChild( $app_image_path );

		$app_descr = & $xmlDoc->createElement("app_descr");
		$app_descr->appendChild($xmlDoc->createCDATASection($this->app_descr));
		$retVal->appendChild( $app_descr);

		$app_descr_url = & $xmlDoc->createElement("app_descr_url");
		$app_descr_url->appendChild($xmlDoc->createCDATASection($this->app_descr_url));
		$retVal->appendChild( $app_descr_url);

		$app_url = & $xmlDoc->createElement("app_url");
		$app_url->appendChild($xmlDoc->createCDATASection($this->app_url));
		$retVal->appendChild( $app_url);

		$app_version = & $xmlDoc->createElement("app_version");
		$app_version->appendChild($xmlDoc->createTextNode($this->app_version));
		$retVal->appendChild( $app_version);

		$app_version_installed = & $xmlDoc->createElement("app_version_installed");
		$app_version_installed->appendChild($xmlDoc->createTextNode($this->app_version_installed));
		$retVal->appendChild( $app_version_installed);

		$app_authors = & $xmlDoc->createElement("app_authors");
		$app_authors->appendChild($xmlDoc->createTextNode($this->app_authors));
		$retVal->appendChild( $app_authors);

		$app_authors_url = & $xmlDoc->createElement("app_authors_url");
		$app_authors_url->appendChild($xmlDoc->createTextNode($this->app_authors_url));
		$retVal->appendChild( $app_authors_url);

		$app_authors_email = & $xmlDoc->createElement("app_authors_email");
		$app_authors_email->appendChild($xmlDoc->createTextNode($this->app_authors_email));
		$retVal->appendChild( $app_authors_email);

		$app_type = & $xmlDoc->createElement("app_type");
		$app_type->appendChild($xmlDoc->createTextNode($this->app_type));
		$retVal->appendChild( $app_type);

		$app_real_type = & $xmlDoc->createElement("app_real_type");
		$app_real_type->appendChild($xmlDoc->createTextNode($this->app_real_type));
		$retVal->appendChild( $app_real_type);

		$app_release_date = & $xmlDoc->createElement("app_release_date");
		$app_release_date->appendChild($xmlDoc->createTextNode($this->app_release_date));
		$retVal->appendChild( $app_release_date);

		$app_recommended = & $xmlDoc->createElement("app_recommended");
		$app_recommended->appendChild($xmlDoc->createTextNode($this->app_recommended));
		$retVal->appendChild( $app_recommended);

		$app_not_commercial = & $xmlDoc->createElement("app_not_commercial");
		$app_not_commercial->appendChild($xmlDoc->createTextNode($this->app_not_commercial));
		$retVal->appendChild( $app_not_commercial);

		$app_relate_id = & $xmlDoc->createElement("app_relate_id");
		$app_relate_id->appendChild($xmlDoc->createTextNode($this->app_relate_id));
		$retVal->appendChild( $app_relate_id );

		$category = & $xmlDoc->createElement("category");
		$category->appendChild($xmlDoc->createTextNode($this->category));
		$retVal->appendChild( $category);

		return $retVal;
	}

	function toXML2(){

		$retVal = "<app_data>\n";
		$retVal .= "<app_name>" . $this->app_name . "</app_name>\n";
		$retVal .= "<app_real_name>" . $this->app_real_name . "</app_real_name>\n";
		$retVal .= "<app_image_path>" . $this->app_image_path . "</app_image_path>\n";
		$retVal .= "<app_descr>" . htmlspecialchars($this->app_descr) . "</app_descr>\n";
		$retVal .= "<app_descr_url>" . $this->app_descr_url . "</app_descr_url>\n";
		$retVal .= "<app_url>" . $this->app_url . "</app_url>\n";
		$retVal .= "<app_version>" . $this->app_version . "</app_version>\n";
		$retVal .= "<app_version_installed>" . $this->app_version_installed . "</app_version_installed>\n";
		$retVal .= "<app_authors>" . $this->app_authors . "</app_authors>\n";
		$retVal .= "<app_authors_url>" . $this->app_authors_url . "</app_authors_url>\n";
		$retVal .= "<app_authors_email>" . $this->app_authors_email . "</app_authors_email>\n";
		$retVal .= "<app_type>" . $this->app_type . "</app_type>\n";
		$retVal .= "<app_real_type>" . $this->app_real_type . "</app_real_type>\n";
		$retVal .= "<app_release_date>" . $this->app_release_date . "</app_release_date>\n";
		$retVal .= "<app_recommended>" . $this->app_recommended . "</app_recommended>\n";
		$retVal .= "<app_not_commercial>" . $this->app_not_commercial . "</app_not_commercial>\n";
		$retVal .= "<app_relate_id>" . $this->app_relate_id . "</app_relate_id>\n";
		$retVal .= "<category>" . $this->category . "</category>\n";
		$retVal .= "</app_data>\n";
		return $retVal;
	}
}
?>
