<?php 
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.model');

class NinjamonialsModelAll extends JModel
{
	var $data = null;
	var $_pagination = null;
	var $_total = null;
	var $_search = null;
	var $_query = null;	
	var $_category = null;
		
	
	function getData()
	{
		$pagination =& $this->getPagination();
		
		if (empty($this->data)) {
			$query = $this->buildSearch();

			$this->data = $this->_getList($query, $pagination->limitstart, $pagination->limit);

		}
		
				
		return $this->data;
	}
	
	function buildSearch()
	{
		if (!$this->_query) {
			$search = $this->getSearch();
			$category = $this->getCategory();
			
			$this->_query = "SELECT nmls.*, nmlsc.name AS cat_name FROM #__ninjamonials nmls
							 LEFT JOIN #__nmls_categories nmlsc ON nmlsc.id = nmls.category_id ";
			
			if ($search != '') {
				$fields = array('nmls.testimonial', 'nmls.summary', 'nmls.author_name', 'nmls.author_title', 'nmls.author_location', 'nmls.website_text', 'nmls.website_url', 'nmlsc.name');
				
				$where = array();
				
				$search = $this->_db->getEscaped( $search, true );
				
				foreach ($fields as $field) {
					$where[] = $field . " LIKE '%{$search}%'";
				}
				
				$srchWhere = implode(' OR ', $where);
			}
			
			if ($category != ''){
				$catWhere = 'nmls.category_id ='.$category; 
			}
			
			if ($category && $search) {
				$this->_query .= ' WHERE '.$catWhere.' AND ('.$srchWhere.') ';
			} elseif ($category){
				$this->_query .= ' WHERE '.$catWhere;
			} elseif ($search){
				$this->_query .= ' WHERE '.$srchWhere;
			}
			
			$this->_query .=' ORDER BY nmls.id DESC ';
		}		
		
		return $this->_query;
	}
	
	function getTotal()
	{
		if (!$this->_total) {
			$query = $this->buildSearch();
			$this->_total = $this->_getListCount($query);
		}
		
		return $this->_total;
	}
	
	function &getPagination() 
	{
		if(!$this->_pagination) {
			jimport('joomla.html.pagination');
			$app = &JFactory::getApplication();
			$this->_pagination = new JPagination($this->getTotal(), JRequest::getVar('limitstart', 0), JRequest::getVar('limit', $app->getCfg('list_limit')));
			
		}
		return $this->_pagination;
	}
	
	function getSearch()
	{
		if (!$this->_search) {
			global $option;
			$app = &JFactory::getApplication();
	
			$search = $app->getUserStateFromRequest( "$option.search", 'search', '', 'string' );
			$this->_search = JString::strtolower($search);
		}
				
		return $this->_search;
	}
	
	function getCategory()
	{
		if (!$this->_category) {
			global $option;
			
			$category = JRequest::getVar('category_id_filter');
	
			$this->_category = $category;
		}
		
		return $this->_category;
	}
	
	function setCategory($category=null)
	{
						
		$this->_category = $category;
	}
	
	function getCatList(){
	
		$db =& JFactory::getDBO();
	
		$sql = 'SELECT id, name FROM #__nmls_categories';
	    $db->setQuery($sql);
	
	//Include a "select category" option as we should allow people to see all categories
		    $catlist[]	= JHTML::_('select.option',  '0', JText::_( '- Select Category -' ), 'id', 'name' );
		    $catlist	= array_merge( $catlist, $db->loadObjectList() );
		
		return JHTML::_('select.genericlist', $catlist, 'category_id_filter', 'class="inputbox" size="1" onchange="document.adminForm.submit();"','id', 'name', $this->getCategory() );
		
	}
	
	
} 
?>
