<?php
/**
* @version		$Id: calendar.php 10707 2008-08-21 09:52:47Z eddieajau $
* @package		Joomla.Framework
* @subpackage	Parameter
* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* Joomla! is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See COPYRIGHT.php for copyright notices and details.
*/

// Check to ensure this file is included in Joomla!
defined( '_JEXEC' ) or die( 'Restricted access' );

/**
 * Renders a calendar element
 *
 * @package 	Joomla.Framework
 * @subpackage	Parameter
 * @since		1.5
 */
class JElementCalendar extends JElement
{
	/**
	* Element name
	* @access	protected
	* @var		string
	*/
	var	$_name = 'Calendar';

	function fetchElement($name, $value, &$node, $control_name)
	{
		$format	= ( $node->attributes('format') ? $node->attributes('format') : 'yy-mm-dd' );
		$class	= $node->attributes('class') ? 'class="'.$node->attributes('class').'"' : 'class="inputbox"';

		$id   = $control_name.$name;
		$name = $control_name.'['.$name.']';
		
		$doc = & JFactory::getDocument();
		$script = "
				jQuery.noConflict();
			
				jQuery(document).ready(function($){
					$('#$id').datepicker({showOn: 'button', buttonImage: '".JURI::root(true)."/templates/system/images/calendar.png', buttonImageOnly: true});
				});
			";
		$doc->addScriptDeclaration($script);
		
		return '<input type="text" '.$class.' name="'.$name.'" id="'.$id.'" value="'.htmlspecialchars($value, ENT_COMPAT, 'UTF-8').'" />';
	}
}
